# Exercise 1

countries<-read.csv2('/Users/Thierry/Documents/R/Data/Economics/countries_of_the_world.csv',
                    row.names=1,sep=",",header=TRUE)

x<-countries[,c(6:10,15:19)]
names(x)<-c("migration","infant.mortality","GDP","literacy","phones","birthrate","deathrate",
            "agriculture","industry","service")
x$GDP<-log(x$GDP)
x$infant.mortality<-log(x$infant.mortality)
x$literacy<-log(x$literacy)

plot(x)

summary(x)

x1<-na.omit(x)
#library(mix)
#x2<-imputeData(x)

pca<-princomp(x1,cor=TRUE)
Z<-pca$scores
lambda<-pca$sdev^2

# Q2
biplot(pca)
biplot(pca,choices = c(1,3))

# Q3
plot(cumsum(lambda)/sum(lambda),type="b",
     xlab="q",ylab="proportion of explained variance")

x2<-Z[,1:5]

library(mclust)
clus<-Mclust(x2)
plot(clus,what="BIC")

clus<-Mclust(x2,G=3)
plot(clus,what="classification",dimens=c(1,2))


which(clus$classification==1)


# Exercise 2


#library(MASS)

data<-read.csv('/Users/Thierry/Documents/R/Data/Economics/Greene/TableF14-1.csv',
                     row.names=1,sep=",",header=TRUE)
attach(data)

# LS regression

fit.ls<-lm(GPA~PSI)
summary(fit.ls)
plot(PSI,GPA)
abline(coef(fit.ls))

fit.ls1<-lm(GPA~PSI+TUCE)
summary(fit.ls1)


# Q1
library(mixtools)

loglikmax<--Inf
for(i in 1:50){
  fit <- regmixEM(GPA,PSI,k=2)
  if(fit$loglik> loglikmax){
    loglikmax<-fit$loglik
    bestfit<-fit
    }
  print(c(fit$loglik,loglikmax))
}


ii1<-bestfit$posterior[,1]>0.5
ii2<-bestfit$posterior[,1]<=0.5
plot(PSI[ii1],GPA[ii1],col='red',ylim=range(GPA),xlim=range(PSI))
points(PSI[ii2],GPA[ii2],col='blue')
abline(bestfit$beta[,1],col='red')
abline(bestfit$beta[,2],col='blue')

# Q2

plot(TUCE,bestfit$posterior[,1])
print(c(mean(TUCE[ii1]),mean(TUCE[ii2])))


# Q3
library(flexmix)

loglikmax<--Inf
for(i in 1:50){
  fit<-flexmix(GPA ~ PSI,k=2,model=FLXMRglm(family="gaussian"),
             concomitant=FLXPmultinom(formula=~TUCE))
  if(logLik(fit) > loglikmax){
    loglikmax<-logLik(fit)
    bestfit<-fit
  }
  print(c(logLik(fit),loglikmax))
}

beta<- parameters(bestfit)[1:2,]
alpha<-bestfit@concomitant@coef

jj1<-posterior(bestfit)[,1]>0.5
jj2<-posterior(bestfit)[,1]<=0.5
plot(PSI[jj1],GPA[jj1],col='red',ylim=range(GPA),xlim=range(PSI))
points(PSI[jj2],GPA[jj2],col='blue')
abline(beta[,1],col='red')
abline(beta[,2],col='blue')


xt<-seq(min(TUCE),max(TUCE,0.1))
N<-length(xt)
pit<-matrix(0,N,2)
for(k in 1:2) pit[,k]<-exp(alpha[1,k]+alpha[2,k]*xt)
pit<-pit/rowSums(pit)
plot(xt,pit[,1],type="l",col="red",xlab="TUCE",ylab="probability")
lines(xt,pit[,2],col="blue")

